close all;
clear all;

rows = 1200;
cols = 1920;
max_value = 255;
number_of_frequencies = 6;
samples_per_freq = cols/number_of_frequencies;
samples = 1:cols;
x = 1:samples_per_freq;

index = 1;
y = zeros(1,cols);
for freq = 1:number_of_frequencies
    y(index:index + samples_per_freq - 1) = (max_value/2)*(1+sin(2*pi*(freq/(samples_per_freq))*x));
    index = index + samples_per_freq;
end

image = zeros(rows, cols);
for j = 1:rows
    image(j,:) = y;
end


rows_per_frequency = rows/number_of_frequencies; 
z = zeros(1,cols); 
image_vertical_freq = zeros(rows, cols); 
modulator = 1;
for k = 0:number_of_frequencies-1 
    for l = 1:rows_per_frequency 
        image_vertical_freq(k*rows_per_frequency + l,:) = (max_value/2)*(1+sin(2*pi*(((k+1)*modulator)/(cols))*samples));
    end
end

imwrite(uint8(image_vertical_freq), 'frequencies.bmp', 'bmp');

figure

subplot(1,2,2)
plot(samples,y);
axis([0 1919 0 255]);
xlabel('Pixel number')
ylabel('Pixel value')
subplot(1,2,1)
imshow(uint8(image));

figure

imshow(uint8(image_vertical_freq));


figure
for m = 1:number_of_frequencies
   
    subplot(number_of_frequencies, 1, m)
    
    plot(samples, image_vertical_freq(m*rows_per_frequency-1,:));
    axis([0 1919 0 255]);
    xlabel('Pixel number')
    ylabel('Pixel value')
    %title(['Frequency number ' num2str(m)]);
    
end