close all;
clear all;

rows = 512;
cols = 512;

max_value = 255;

gradient_horizontal = zeros(rows, cols);
gradient_vertical = zeros(rows, cols);

for j = 1:cols
    for i = 1:rows
        gradient_horizontal(j,i) = round(i * max_value/rows);
    end
end

for j = 1:rows
    for i = 1:cols
        gradient_vertical(i,j) = round(i * max_value/cols);
    end
end

image_bad_horizontal_sync = zeros(rows, cols);
image_bad_horizontal_sync(:,1:cols-99) = gradient_horizontal(:,100:cols);
image_bad_horizontal_sync(:,cols-99:cols) = gradient_horizontal(:,1:100);

imwrite(uint8(gradient_horizontal), 'gradient.bmp', 'bmp');

figure
imshow(uint8(image_bad_horizontal_sync), [0 max_value]);

figure
subplot(1,2,1)
imshow(uint8(gradient_horizontal), [0 max_value]);
%line([0 cols-1], [50 50], 'LineWidth',2,'Color', [0 0 0])

subplot(1,2,2)
plot(gradient_horizontal(50,:));
axis([0 cols 0 255])
xlabel('Pixel number')
ylabel('Pixel value')

figure
subplot(1,2,1)
imshow(uint8(gradient_vertical), [0 max_value]);
%line([0 cols-1], [50 50], 'LineWidth',2,'Color', [0 0 0])

subplot(1,2,2)
plot(gradient_vertical(:,50));
axis([0 rows 0 255])
xlabel('Row number')
ylabel('Pixel value')