function saveDataToLatex(dataArray, fileName, fileType)

[x,y] = size(dataArray);
fileID = fopen([fileName '.' fileType],'w');

fprintf(fileID, '\\begin{table}[ht]\n');
fprintf(fileID, '\\centering\n');
fprintf(fileID, '\\caption[generatedTable description]{Description of the generatedTable.}\n');
fprintf(fileID, '\\begin{tabular}{|');

for settingLoop = 1:y
    fprintf(fileID, ' c |');
end;

fprintf(fileID,'}\n\\hline \n');

for titleLoop = 1:y
    fprintf(fileID,'Title %d ', titleLoop); 
    if (titleLoop ~= y)
        fprintf(fileID,' & ');
    end
end

fprintf(fileID,'\n \\hline \n');

fprintf(fileID, '\\multicolumn{4}{|c|}{Image Name} \\\\ \\hline \\hline \n');

for j = 1:x
        for i = 1:y
            if (i == 1)
                fprintf(fileID,'%.2f', dataArray(j,i));
            else
                fprintf(fileID,'%d', dataArray(j,i));
            end
            if (i ~= y)
                fprintf(fileID,' & ');
            end
        end
        fprintf(fileID,' \\\\ \\hline \n');
end

fprintf(fileID, '\\end{tabular}\n');
fprintf(fileID, '\\label{tab:%s}\n', fileName);
fprintf(fileID, '\\end{table}');

fclose(fileID);