%%  Script reads in an image an contaminates it with the desired type of noise at different intensities. 
%   The resulting images are written to bitmap files with the appropriate
%   file name. The images are used for testing and evaluating the metrics.

image_name = 'frequencies';
noise_type = 'speckle';
intensities = 0:0.01:0.1;

noise_mean = 0;
noise_intensity = 0;
channelMaxValue = 255;

image = imread([image_name '.bmp']);
[rows,cols,dim] = size(image);

for noise_intensity = intensities
    
    if (strcmp(noise_type, 'gaussian'))
        firstFrame = imnoise(image, 'gaussian', noise_mean, noise_intensity);
        secondFrame = imnoise(image, 'gaussian', noise_mean, noise_intensity);
    elseif (strcmp(noise_type,'salt_and_pepper'))
        firstFrame = imnoise(image, 'salt & pepper', noise_intensity);
        secondFrame = imnoise(image, 'salt & pepper', noise_intensity);
    elseif (strcmp(noise_type,'speckle'))
        firstFrame = imnoise(image, 'speckle', noise_intensity);
        secondFrame = imnoise(image, 'speckle', noise_intensity);    
    else
        firstFrame = imnoise(image, 'gaussian', noise_mean, noise_intensity);
        secondFrame = imnoise(image, 'gaussian', noise_mean, noise_intensity);
    end
    
    image_string_firstFrame = [image_name '_' noise_type '_noise_with_intensity_' num2str(noise_intensity) '_firstFrame.bmp'];
    image_string_secondFrame = [image_name '_' noise_type '_noise_with_intensity_' num2str(noise_intensity) '_secondFrame.bmp'];
    
    textFile_string_firstFrame = [image_name '_' noise_type '_noise_with_intensity_' num2str(noise_intensity) '_firstFrame.txt'];
    textFile_string_secondFrame = [image_name '_' noise_type '_noise_with_intensity_' num2str(noise_intensity) '_secondFrame.txt'];
    
    imwrite(firstFrame, image_string_firstFrame, 'bmp');
    imwrite(secondFrame, image_string_secondFrame, 'bmp');

%     fileID = fopen(textFile_string_firstFrame,'w');
%     for i = 1:rows
%         for j = 1:cols
%             fprintf(fileID,'%d ',firstFrame(i, j, 1));
%             fprintf(fileID,'%d ',firstFrame(i, j, 2));
%             fprintf(fileID,'%d ',firstFrame(i, j, 3));
%             if (j == cols)
%                 fprintf(fileID,'%d ',0);
%             else
%                 fprintf(fileID,'%d ',1);
%             end
%             if (i == rows && j == cols)
%                 fprintf(fileID,'%d ',0);
%             else
%                 fprintf(fileID,'%d ',1);
%             end
%             fprintf(fileID,'\n');
%         end
%     end
%     
%     % Uncomment for separate files:
%     %fclose(fileID);
%     %fileID = fopen(textFile_string_secondFrame,'w');
%     
%     for i = 1:rows
%         for j = 1:cols
%             fprintf(fileID,'%d ',secondFrame(i, j, 1));
%             fprintf(fileID,'%d ',secondFrame(i, j, 2));
%             fprintf(fileID,'%d ',secondFrame(i, j, 3));
%             if (j == cols)
%                 fprintf(fileID,'%d ',0);
%             else
%                 fprintf(fileID,'%d ',1);
%             end
%             if (i == rows && j == cols)
%                 fprintf(fileID,'%d ',0);
%             else
%                 fprintf(fileID,'%d ',1);
%             end
%             fprintf(fileID,'\n');
%         end
%     end
%     fclose(fileID);
end;