close all;
clear all;

original_image = imread('gradientImage.bmp');
%original_image = original_image(:,:,3);
%rgb2gray(original_image);

dark_image = imadjust(original_image, [0; 1], [0; 0.5]);
light_image = imadjust(original_image, [0; 1], [0.5; 1]);

high_contrast_image = imadjust(original_image, [0.25; 0.75], [0; 1]);
% low_contrast_image = imadjust(original_image, [0 0.2],[0.5 1]);

figure

subplot(2,2,1)
imshow(dark_image)
subplot(2,2,2)
imhist(dark_image)

subplot(2,2,3)
imshow(light_image)
subplot(2,2,4)
imhist(light_image)

figure

subplot(1,2,1)
imshow(high_contrast_image)
subplot(1,2,2)
imhist(high_contrast_image)

figure

[histogram, bins] = imhist(original_image, 256);
threshold = 0;

dynamic_range_placement = [5500 5500];
dynamic_range = [find(histogram>threshold, 1, 'first') find(histogram>threshold, 1, 'last')];
complete_range_placement = [5750 5750];
complete_range = [0 255];

bar(histogram, 0.3);
line(dynamic_range, dynamic_range_placement, 'LineWidth',2,'Color', [0 0 0])
%line(complete_range, complete_range_placement, 'LineWidth',2,'Color', [0 0 0])
axis([0 255 0 6000])
ylabel('Histogram values')
xlabel('Bar number')

dynamic_range