--=============================================================================
-- Project: 
-- Copyright: 
-- Author: 
-- Revision:  
-- Last revised: 
-- Workfile: 
-- Archive: 
-------------------------------------------------------------------------------
-- Description:
-- 
-- 
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Revision History:
--
-- 
-- 
--=============================================================================

library IEEE;					
use IEEE.STD_LOGIC_1164.all; 
use ieee.numeric_std.all;								 

entity vqa_colorTesting_accumulator is
	generic(
		channelMaxValue : integer := 255
		);
	port(
		vqa_colorTesting_accumulator_clk : in std_logic;
		vqa_colorTesting_accumulator_nReset : in std_logic;
		vqa_colorTesting_accumulator_channelInput : in integer range 0 to channelMaxValue;
		vqa_colorTesting_accumulator_result : out integer range 0 to channelMaxValue
		);
end;

architecture behaviour of vqa_colorTesting_accumulator is
	
signal sum : integer range 0 to 255 := 0;
	
begin
	vqa_colorTesting_accumulator_result <= sum;
	
	accum_proc: process (vqa_colorTesting_accumulator_clk, vqa_colorTesting_accumulator_nReset)
	begin
		if (vqa_colorTesting_accumulator_nReset = '0') then
			sum  <= 0;
		elsif (rising_edge(vqa_colorTesting_accumulator_clk)) then
			sum <= vqa_colorTesting_accumulator_channelInput + sum;
		end if;
	end process accum_proc;
	
end behaviour;
