--=============================================================================
-- Project: 
-- Copyright: 
-- Author: 
-- Revision:  
-- Last revised: 
-- Workfile: 
-- Archive: 
-------------------------------------------------------------------------------
-- Description:
-- !!Contains dead code!!
-- 
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Revision History:
--
-- 
-- 
--=============================================================================

library IEEE;					
use IEEE.STD_LOGIC_1164.all;

entity vqa_colorTesting_control is
	generic (						 
		-- Number of bits used for representing each color.
		channelMaxValue : integer := 255;
		vgaImageWidth : integer := 320;
		vgaImageLength : integer := 200
		);
	port (		
		-- SYSTEM INPUTS:
		vqa_colorTesting_control_nReset : in std_logic;
		vqa_colorTesting_control_hSync : in std_logic;
		vqa_colorTesting_control_vSync : in std_logic;
		vqa_colorTesting_control_select : out std_logic_vector(1 downto 0)
		);
end vqa_colorTesting_control;

architecture behaviour of vqa_colorTesting_control is 	  

	constant boundaryRG : integer := vgaImageLength/3;
	constant boundaryGB : integer := (2*vgaImageLength)/3;	
	
	signal counter : integer range 0 to channelMaxValue := 0;
	
begin		 
	
	counter_proc : process(vqa_colorTesting_control_hSync, vqa_colorTesting_control_nReset)	
	begin																			
		if (vqa_colorTesting_control_nReset = '0') then
			counter <= 0;
		elsif (rising_edge(vqa_colorTesting_control_hSync)) then
			if (vqa_colorTesting_control_vSync = '1') then
				counter <= 0;
			else			 
				counter <= counter + 1;
			end if;
		end if;
	end process counter_proc;
	
	control_proc : process(vqa_colorTesting_control_hSync, vqa_colorTesting_control_nReset)
	begin
		if (vqa_colorTesting_control_nReset = '0') then			
			vqa_colorTesting_control_select <= "00"; 
		elsif (rising_edge(vqa_colorTesting_control_hSync)) then  
			if counter = 0 then
				vqa_colorTesting_control_select <= "00";
			elsif counter = boundaryRG then
				vqa_colorTesting_control_select <= "01";
			elsif counter = boundaryGB then
				vqa_colorTesting_control_select <= "11";
			else
				null;
			end if;
		end if;
	end process control_proc;
	
end architecture behaviour;