--=============================================================================
-- Project: 
-- Copyright: 
-- Author: 
-- Revision:  
-- Last revised: 
-- Workfile: 
-- Archive: 
-------------------------------------------------------------------------------
-- Description:
-- 
-- 
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Revision History:
--
-- 
-- 
--=============================================================================

-- This package defines a set of unsigned arithmetic, conversion,
-- and comparison functions for STD_LOGIC_VECTOR.
library IEEE;					
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;									 

entity vqa_colorTesting_mux is
	generic(
		channelMaxValue : integer := 255
		);
	port(
		vqa_colorTesting_mux_clk : in std_logic;
		vqa_colorTesting_mux_nReset : in std_logic;
		vqa_colorTesting_mux_select : in std_logic_vector(1 downto 0); -- 00 => red, 01 => green, 11 => blue  
		vqa_colorTesting_mux_vgaRed : in integer range 0 to channelMaxValue;
		vqa_colorTesting_mux_vgaGreen : in integer range 0 to channelMaxValue;
		vqa_colorTesting_mux_vgaBlue : in integer range 0 to channelMaxValue;
		vqa_colorTesting_mux_result : out integer range 0 to channelMaxValue
		);
end;

architecture behaviour of vqa_colorTesting_mux is
begin
	with vqa_colorTesting_mux_select select
		vqa_colorTesting_mux_result <= vqa_colorTesting_mux_vgaRed when "00",
		vqa_colorTesting_mux_vgaGreen when "01",
		vqa_colorTesting_mux_vgaBlue when "11",
		0 when others;
		--(others => '0') when others;
end behaviour;
