--=============================================================================
-- Project: 
-- Copyright: 
-- Author: 
-- Revision:  
-- Last revised: 
-- Workfile: 
-- Archive: 
-------------------------------------------------------------------------------
-- Description:
-- 
-- 
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Revision History:
--
-- 
-- 
--=============================================================================

-- This package defines a set of unsigned arithmetic, conversion,
-- and comparison functions for STD_LOGIC_VECTOR.
library IEEE;					
use IEEE.STD_LOGIC_1164.all;

entity vqa_colorTesting_tresholdTesting is
	generic(
		channelMaxValue : integer := 255;
		primaryTreshold : integer := 250;
		secondaryTreshold : integer := 255
		);
	port(									
		-- SYSTEM INPUTS:
		vqa_colorTesting_tresholdTesting_clk : in std_logic;
		vqa_colorTesting_tresholdTesting_nReset : in std_logic;
		-- VGA SPECIFIC INPUTS:
		vqa_colorTesting_tresholdTesting_vgaClk : in std_logic;
		vqa_colorTesting_tresholdTesting_vgaRed : in integer range 0 to channelMaxValue; 
--		vqa_colorTesting_tresholdTesting_vgaGreen : in integer range 0 to channelMaxValue;
--		vqa_colorTesting_tresholdTesting_vgaBlue : in integer range 0 to channelMaxValue; 
		vqa_colorTesting_tresholdTesting_hSync : in std_logic;
		vqa_colorTesting_tresholdTesting_vSync : in std_logic;
		-- METRIC OUTPUT
		vqa_colorTesting_tresholdTesting_redMetric : out integer
--		vqa_colorTesting_tresholdTesting_greenMetric : out integer;
--		vqa_colorTesting_tresholdTesting_blueMetric : out integer
		);
end entity vqa_colorTesting_tresholdTesting; 

architecture behaviour of vqa_colorTesting_tresholdTesting is
	
	type state is (normal, vsync, hsync);
	signal currentState, nextState : state;
	
begin
	
	TEST_PROC : process(currentState, vqa_colorTesting_tresholdTesting_hSync, vqa_colorTesting_tresholdTesting_vSync, vqa_colorTesting_tresholdTesting_vgaRed)--, vqa_colorTesting_tresholdTesting_vgaGreen, vqa_colorTesting_tresholdTesting_vgaBlue)
		
		-- Counter variables:
		variable redCounter_primary : integer := 0;
--		variable greenCounter_primary : integer := 0;
--		variable blueCounter_primary : integer := 0;
		variable redCounter_secondary : integer := 0;
--		variable greenCounter_secondary : integer := 0;
--		variable blueCounter_secondary : integer := 0;
		
		-- Metric variables:
		variable redMetric : integer := 0;
--		variable greenMetric : integer := 0;
--		variable blueMetric : integer := 0;
		
begin
	nextState <= normal;
	redCounter_primary := 0;
	redCounter_secondary := 0;
	
		case currentState is
			when normal => 
				
				RED_TEST:
				if (vqa_colorTesting_tresholdTesting_vgaRed < 250) then
					redCounter_primary := redCounter_primary + 1;
				elsif (vqa_colorTesting_tresholdTesting_vgaRed < 255) then
					redCounter_secondary := redCounter_secondary + 1;
				else											 
					redCounter_primary := redCounter_primary;
					redCounter_secondary := redCounter_secondary;
				end if RED_TEST;	 
				
--				GREEN_TEST:
--				if (vqa_colorTesting_tresholdTesting_vgaGreen < 250) then
--					greenCounter_primary := greenCounter_primary + 1;
--				elsif (vqa_colorTesting_tresholdTesting_vgaGreen < 255) then
--					greenCounter_secondary := greenCounter_secondary + 1; 
--				else
--					greenCounter_primary := greenCounter_primary;
--					greenCounter_secondary := greenCounter_secondary;
--				end if GREEN_TEST;
--				
--				BLUE_TEST:
--				if (vqa_colorTesting_tresholdTesting_vgaBlue < 250) then
--					blueCounter_primary := blueCounter_primary + 1;
--				elsif (vqa_colorTesting_tresholdTesting_vgaBlue < 255) then
--					blueCounter_secondary := blueCounter_secondary + 1;
--				else
--					blueCounter_primary := blueCounter_primary;
--					blueCounter_secondary := blueCounter_secondary;
--				end if BLUE_TEST;
				
				CALCULATE_NEXT_STATE: 
				if (vqa_colorTesting_tresholdTesting_vSync = '1') then
					nextState <= vsync;
				elsif (vqa_colorTesting_tresholdTesting_hSync = '1') then
					nextState <= hsync;
				else
					nextState <= normal;
				end if CALCULATE_NEXT_STATE;
				
			when hsync => 	
				vqa_colorTesting_tresholdTesting_redMetric <= (2*redCounter_primary) + redCounter_secondary;
--				vqa_colorTesting_tresholdTesting_greenMetric <= (2*greenCounter_primary) + greenCounter_secondary;
--				vqa_colorTesting_tresholdTesting_blueMetric <= (2*blueCounter_primary) + blueCounter_secondary;
			
			when vsync =>
				vqa_colorTesting_tresholdTesting_redMetric <= 0;
--				vqa_colorTesting_tresholdTesting_greenMetric <= 0;
--				vqa_colorTesting_tresholdTesting_blueMetric <= 0;
			
			when others =>
			NULL;
			
		end case;
		
	end process TEST_PROC;
	
	STATE_REG: process(vqa_colorTesting_tresholdTesting_vgaClk, vqa_colorTesting_tresholdTesting_nReset)
	begin
		RESET_CLOCK_TEST:
		if (vqa_colorTesting_tresholdTesting_nReset = '0') then
			currentState <= normal;
		elsif (vqa_colorTesting_tresholdTesting_vgaClk'event and vqa_colorTesting_tresholdTesting_vgaClk = '1') then
			currentState <= nextState;
		end if RESET_CLOCK_TEST;
	end process STATE_REG;
	
	
end architecture behaviour;
