--=============================================================================
-- Project: Video quality analysis using an FPGA
-- Author: Eirik T?rud Nordeng
--=============================================================================
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.numeric_std.all;

--library lpm;
--use lpm.lpm_components.all;

entity comparator is
	generic(
		channel_width : integer := 8
		);
	port (
		clk : in  std_logic;
		reset : in  std_logic;
		
		data_in : in integer range 0 to 1020;
		
		data_out : out integer range 0 to 1020
		);
end comparator;	 

architecture behaviour of comparator is

--	COMPONENT lpm_compare
--	GENERIC (
--		lpm_pipeline		: NATURAL;
--		lpm_representation		: STRING;
--		lpm_type		: STRING;
--		lpm_width		: NATURAL
--	);
--	PORT (
--			aclr	: IN STD_LOGIC ;
--			agb	: OUT STD_LOGIC ;
--			clock	: IN STD_LOGIC ;
--			datab	: IN STD_LOGIC_VECTOR (8 DOWNTO 0);
--			dataa	: IN STD_LOGIC_VECTOR (8 DOWNTO 0)
--	);
--	END COMPONENT;
--	for all: lpm_compare use entity lpm.lpm_compare(lpm_syn);
		
	signal largest_value : integer range 0 to 1020;
	
--	signal dataa_to_comparator : std_logic_vector (8 downto 0);
--	signal datab_to_comparator : std_logic_vector (8 downto 0);
--	
--	signal larger : std_logic;
	
begin
	
--	dataa_to_comparator <= std_logic_vector(to_unsigned(data_in_reg, 9));
--	datab_to_comparator <= std_logic_vector(to_unsigned(largest_value, 9));
--	
--	LPM_COMPARE_component : LPM_COMPARE
--	GENERIC MAP (
--		lpm_pipeline => 3,
--		lpm_representation => "UNSIGNED",
--		lpm_type => "LPM_COMPARE",
--		lpm_width => 9
--	)
--	PORT MAP (
--		aclr => reset,
--		clock => clk,
--		dataa => dataa_to_comparator,
--		datab => datab_to_comparator,
--		agb => larger
--	);
	
	compare : process(clk)
	begin
		if (rising_edge(clk)) then
			if (reset = '1') then
				largest_value <= 0;
			else				  
				if (data_in > largest_value) then
					largest_value <= data_in;
				end if;	
			end if;
		end if;
	end process compare;
	
	data_out <= largest_value;
	
end architecture behaviour;
