--=============================================================================
-- Project: Video quality analysis using an FPGA
-- Author: Eirik T�rud Nordeng
--=============================================================================
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.numeric_std.all;

entity sorter_2 is
	generic(
		channel_width : integer := 8
		);
	port (
		upper_data_in   : in  integer range 0 to (2**channel_width - 1);
		lower_data_in   : in  integer range 0 to (2**channel_width - 1);
		
		upper_data_out  : out integer range 0 to (2**channel_width - 1);
		lower_data_out  : out integer range 0 to (2**channel_width - 1)
		);
end sorter_2;

architecture behaviour of sorter_2 is
	
	signal swap : std_logic;
	
begin
	
	swapper_proc : process(upper_data_in, lower_data_in, swap)
	begin						 
		if (swap = '1') then
			upper_data_out <= lower_data_in;
			lower_data_out <= upper_data_in;
		else
			upper_data_out <= upper_data_in;
			lower_data_out <= lower_data_in;
		end if;
	end process swapper_proc;
	
	compare_proc : process(upper_data_in, lower_data_in)
	begin					
		if (upper_data_in < lower_data_in) then
			swap <= '1';
		else  
			swap <= '0';
		end if;
	end process compare_proc;
	
end architecture behaviour;
